using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Windows;
using GlobalHookDemo.Database;
using GlobalHookDemo.Views;

namespace GlobalHookDemo
{
    class MainForm : System.Windows.Forms.Form
    {
        [DllImport("user32.dll")]
        public static extern IntPtr SetWindowLong(IntPtr hWnd, int nIndex, int dwNewLong);
        [DllImport("user32.dll")]
        public static extern int GetWindowLong(IntPtr hWnd, int nIndex);

        private const int GWL_EXSTYLE = -20;
        private Button button1;
        private const int WS_EX_NOACTIVATE = 0x08000000;
        private DictionaryControl dictionaryControl;

        private SettingsForm settingsForm;

        protected override void OnActivated(EventArgs e)
        {
            base.OnActivated(e);
            SetWindowLong(Handle, GWL_EXSTYLE,
            GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);
        }

        protected override void OnGotFocus(EventArgs e)
        {
            base.OnActivated(e);
            SetWindowLong(Handle, GWL_EXSTYLE,
            GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);

        }

        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams param = base.CreateParams;
                param.ExStyle |= WS_EX_NOACTIVATE;
                return param;
            }
        }

        // THIS METHOD IS MAINTAINED BY THE FORM DESIGNER
        // DO NOT EDIT IT MANUALLY! YOUR CHANGES ARE LIKELY TO BE LOST
        void InitializeComponent()
        {
            this.button1 = new System.Windows.Forms.Button();
            this.dictionaryControl = new DictionaryControl();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(227, 13);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(47, 46);
            this.button1.TabIndex = 1;
            this.button1.Text = "button1";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click_1);
            // 
            // listBox1
            // 
            this.dictionaryControl.Location = new System.Drawing.Point(13, 13);
            this.dictionaryControl.Name = "listBox1";
            this.dictionaryControl.Size = new System.Drawing.Size(189, 134);
            this.dictionaryControl.TabIndex = 2;
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(306, 169);
            this.Controls.Add(this.dictionaryControl);
            this.Controls.Add(this.button1);
            this.Name = "MainForm";
            this.Text = "Dictionary";
            this.ResumeLayout(false);

        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            settingsForm.ShowDialog(this);
            settingsForm.Activate();
        }

        public MainForm()
        {
            settingsForm = new SettingsForm();
            InitializeComponent();
            SetWindowLong(Handle, GWL_EXSTYLE,
            GetWindowLong(Handle, GWL_EXSTYLE) | WS_EX_NOACTIVATE);
            this.MaximumSize = this.MinimumSize = this.Size; // prevent resizing
            this.MinimizeBox = false;
            this.MaximizeBox = false;
            this.TopMost = true;
        }
    }
}
