﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Markup;

namespace GlobalHookDemo.i18n
{
    [MarkupExtensionReturnType(typeof(string), typeof(string))]
    public class TranslateExtension : MarkupExtension
    {

        string _key;

        public TranslateExtension(string key)
        {
            _key = key;
        }

        const string NotFoundError = "#StringNotFound#";

        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            if (string.IsNullOrEmpty(_key))
                return NotFoundError;

            return Strings.ResourceManager.GetString(_key) ?? NotFoundError;
        }

    }
}
